unit AvramsAutoUpdate;

interface
  uses  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, idglobal, urlmon, inifiles;

type
  TAvramsAutoUpdater = class
  private
    ini:TIniFile;
    brfajlova,filesize,filetime:integer;
    fajl:string;
    trenutnifajl:string;
    size,time:integer;

    TempFolderPath:string;
    IniFilePath:string;
    NewFiles:TStringList;
    filenames:array of string;
    filesizes,filetimes:array of integer;
    IniFileURL:string;    
    function DownloadFile(source,destination:string):boolean;
    function GetTempDir():string;
    function ExtractWebFileName(fajl:string):string;
  public
    AutoUpdateURL,IniFileName,AppPath:string;
    AAU_LASTERROR:string;
    function DownloadIniFile():boolean;
    function ParseIniFile():boolean;
    function GetNewFiles():boolean;
    function DownloadNewFiles():boolean;
    constructor Create();
    destructor Destroy();
end;

implementation

{ TAvramsAutoUpdater }

constructor TAvramsAutoUpdater.Create;
begin
TempFolderPath:=GetTempDir + '\';
NewFiles := TStringList.Create;
end;

destructor TAvramsAutoUpdater.Destroy;
begin
NewFiles.Free;
end;

function TAvramsAutoUpdater.DownloadFile(source,
  destination: string): boolean;
var
SourceFile, LocalFile: string;
begin
SourceFile := source;
LocalFile := destination;
if URLDownloadToFile(nil, PChar(SourceFile), PChar(LocalFile), 0, nil) = 0 then
  result := true
else
  result := false;
end;

function TAvramsAutoUpdater.DownloadIniFile: boolean;
begin
IniFileURL:=AutoUpdateURL+IniFileName;
 IniFilePath:=TempFolderPath+ExtractWebFileName(IniFileURL);
if DownloadFile(IniFileURL,IniFilePath) then
  Result := true
else begin
  AAU_LASTERROR:='Error downloading ini file:'+#13+IniFileName;
  Result := false;
end;
end;

function TAvramsAutoUpdater.DownloadNewFiles: boolean;
var broj_fajlova,loopisha:integer;
begin
result:=true;
broj_fajlova:=NewFiles.Count;
 for loopisha:=0 to broj_fajlova-1 do begin
   if not DownloadFile(AutoUpdateURL+NewFiles[loopisha],AppPath+NewFiles[loopisha]+'.new') then begin
    AAU_LASTERROR:='Could not download file:'+#13+NewFiles[loopisha];
    Result:=false;
    exit;
   end;
 end;
end;

function TAvramsAutoUpdater.ExtractWebFileName(fajl: string): string;
var tmpa:string;
begin
tmpa:=StringReplace(fajl,'/','\',[rfReplaceAll]);
tmpa:=extractfilename(tmpa);
Result := tmpa;
end;

function TAvramsAutoUpdater.GetNewFiles: boolean;
var loop2:integer;
begin
  for loop2:=0 to brfajlova-1 do begin
    trenutnifajl:=AppPath+filenames[loop2];
    if not FileExists(trenutnifajl) then begin AAU_LASTERROR:='File not exists:'+#13+trenutnifajl; Result:=false; Break; end;
    size:=strtoint(floattostr(FileSizeByName(trenutnifajl)));
    time:=FileAge(trenutnifajl);
      if ((size<>filesizes[loop2]) or (time<>filetimes[loop2])) then NewFiles.Add(filenames[loop2]);
  end;
end;

function TAvramsAutoUpdater.GetTempDir: string;
var sTmpDir:PChar;
    path:string;
begin
  GetMem(sTmpDir, 144);
  GetTempPath(144, sTmpDir);
  path := sTmpDir;
  SetLength(path,Length(path)-1);
  FreeMem(sTmpDir, 144);
  result := path;
end;

function TAvramsAutoUpdater.ParseIniFile: boolean;
var loop:integer;
begin
IniFilePath:=TempFolderPath+IniFileName;
result:=true;
 if not FileExists(IniFilePath) then begin AAU_LASTERROR:='No ini file found. Download it first!'; Result:=false; exit; end;

ini:=TIniFile.Create(IniFilePath);
brfajlova:=ini.ReadInteger('AutoUpdateData','numberoffiles',0);
SetLength(filesizes,brfajlova-1);
SetLength(filenames,brfajlova-1);
SetLength(filetimes,brfajlova-1);
 for loop:=0 to brfajlova-1 do begin
   fajl:=ini.ReadString('File'+IntToStr(loop+1),'filename','');
   filesize:=ini.ReadInteger('File'+IntToStr(loop+1),'filesize',0);
   filetime:=ini.ReadInteger('File'+IntToStr(loop+1),'filetime',0);
   filenames[loop]:=fajl;
   filesizes[loop]:=filesize;
   filetimes[loop]:=filetime;
 end;
ini.Free;
end;

end.
